#ifndef MATRIX_H
#define MATRIX_H

#include <vector>
#include <cassert>


template<typename T>
class Matrix {
public:
    typedef T					 value_type;

    inline Matrix(int row, int col) : _rows(row), _cols(col), _data(row*col) {
    }

    inline T &at(int row, int col) {
//        std::assert(row >= 0 && row < _rows);
//        std::assert(col >= 0 && col < _cols);
        return _data[row*_cols + col];
    }

    inline const T &at(int row, int col) const {
//        std::assert(row >= 0 && row < _rows);
//        std::assert(col >= 0 && col < _cols);
        return _data[row*_cols + col];
    }

    inline int rows() const {
        return _rows;
    }

    inline int cols() const {
        return _cols;
    }

    void print() const {
        for(int row=0; row < _rows; row++) {
            //            std::cout << "{";
            for(int col=0; col < _cols; col++) {
                for(auto e : at(row, col)) {
                    std::cout <<  e;
                }
                std::cout << "\t";
            }
            //            std::cout << "}";
            std::cout << "\n";
        }

    }

private:
    int _rows;
    int _cols;

    std::vector<T> _data;
};

#endif // MATRIX_H
